std::vector< _Tp, _Alloc >(3)

NAME
std::vector< _Tp, _Alloc > -

SYNOPSIS

Inherits std::_Vector_base< _Tp, _Alloc >.

  Public Types
typedef _Alloc allocator_type
typedef __gnu_cxx::__normal_iterator< const_pointer, vector > const_iterator
typedef _Alloc_traits::const_pointer const_pointer
typedef _Alloc_traits::const_reference const_reference
typedef std::reverse_iterator< const_iterator > const_reverse_iterator
typedef ptrdiff_t difference_type
typedef __gnu_cxx::__normal_iterator< pointer, vector > iterator
typedef _Base::pointer pointer
typedef _Alloc_traits::reference reference
typedef std::reverse_iterator< iterator > reverse_iterator
typedef size_t size_type
typedef _Tp value_type

  Public Member Functions
vector () noexcept(is_nothrow_default_constructible< _Alloc >::value)
vector (const allocator_type &__a) noexcept
vector (size_type __n, const allocator_type &__a=allocator_type())
vector (size_type __n, const value_type &__value, const allocator_type &__a=allocator_type())
vector (const vector &__x)
vector (vector &&__x) noexcept
vector (const vector &__x, const allocator_type &__a)
vector (vector &&__rv, const allocator_type &__m) noexcept(_Alloc_traits::_S_always_equal())
vector (initializer_list< value_type > __l, const allocator_type &__a=allocator_type())
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> vector (_InputIterator __first, _InputIterator __last, const allocator_type &__a=allocator_type())
~vector () noexcept
void assign (size_type __n, const value_type &__val)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void assign (_InputIterator __first, _InputIterator __last)
void assign (initializer_list< value_type > __l)
reference at (size_type __n)
const_reference at (size_type __n) const
reference back () noexcept
const_reference back () const noexcept
iterator begin () noexcept
const_iterator begin () const noexcept
size_type capacity () const noexcept
const_iterator cbegin () const noexcept
const_iterator cend () const noexcept
void clear () noexcept
const_reverse_iterator crbegin () const noexcept
const_reverse_iterator crend () const noexcept
_Tp * data () noexcept
const _Tp * data () const noexcept
template<typename... _Args> iterator emplace (const_iterator __position, _Args &&...__args)
template<typename... _Args> void emplace_back (_Args &&...__args)
bool empty () const noexcept
iterator end () noexcept
const_iterator end () const noexcept
iterator erase (const_iterator __position)
iterator erase (const_iterator __first, const_iterator __last)
reference front () noexcept
const_reference front () const noexcept
iterator insert (const_iterator __position, const value_type &__x)
iterator insert (const_iterator __position, value_type &&__x)
iterator insert (const_iterator __position, initializer_list< value_type > __l)
iterator insert (const_iterator __position, size_type __n, const value_type &__x)
template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> iterator insert (const_iterator __position, _InputIterator __first, _InputIterator __last)
size_type max_size () const noexcept
vector & operator= (const vector &__x)
vector & operator= (vector &&__x) noexcept(_Alloc_traits::_S_nothrow_move())
vector & operator= (initializer_list< value_type > __l)
reference operator[] (size_type __n) noexcept
const_reference operator[] (size_type __n) const noexcept
void pop_back () noexcept
void push_back (const value_type &__x)
void push_back (value_type &&__x)
reverse_iterator rbegin () noexcept
const_reverse_iterator rbegin () const noexcept
reverse_iterator rend () noexcept
const_reverse_iterator rend () const noexcept
void reserve (size_type __n)
void resize (size_type __new_size)
void resize (size_type __new_size, const value_type &__x)
void shrink_to_fit ()
size_type size () const noexcept
void swap (vector &__x) noexcept(_Alloc_traits::_S_nothrow_swap())

  Protected Member Functions
pointer _M_allocate (size_t __n)
template<typename _ForwardIterator > pointer _M_allocate_and_copy (size_type __n, _ForwardIterator __first, _ForwardIterator __last)
template<typename _InputIterator > void _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator > void _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _Integer > void _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
template<typename _InputIterator > void _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
size_type _M_check_len (size_type __n, const char *__s) const
void _M_deallocate (pointer __p, size_t __n)
void _M_default_append (size_type __n)
void _M_default_initialize (size_type __n)
template<typename... _Args> void _M_emplace_back_aux (_Args &&...__args)
iterator _M_erase (iterator __position)
iterator _M_erase (iterator __first, iterator __last)
void _M_erase_at_end (pointer __pos) noexcept
void _M_fill_assign (size_type __n, const value_type &__val)
void _M_fill_initialize (size_type __n, const value_type &__value)
void _M_fill_insert (iterator __pos, size_type __n, const value_type &__x)
_Tp_alloc_type & _M_get_Tp_allocator () noexcept
const _Tp_alloc_type & _M_get_Tp_allocator () const noexcept
template<typename _Integer > void _M_initialize_dispatch (_Integer __n, _Integer __value, __true_type)
template<typename _InputIterator > void _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename... _Args> void _M_insert_aux (iterator __position, _Args &&...__args)
template<typename _Integer > void _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __val, __true_type)
template<typename _InputIterator > void _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
void _M_range_check (size_type __n) const
template<typename _InputIterator > void _M_range_initialize (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator > void _M_range_initialize (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _InputIterator > void _M_range_insert (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator > void _M_range_insert (iterator __pos, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
bool _M_shrink_to_fit ()
allocator_type get_allocator () const noexcept

  Protected Attributes
_Vector_impl _M_impl

Detailed Description

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>>class std::vector< _Tp, _Alloc >
A standard container which offers fixed time access to individual elements in any order.

Template Parameters:
    _Tp Type of element.
    _Alloc Allocator type, defaults to allocator<_Tp>.

Meets the requirements of a container, a reversible container, and a sequence, including the optional sequence requirements with the exception of push_front and pop_front.

In some terminology a vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( [] ) access is also provided as with C-style arrays.

Definition at line 214 of file stl_vector.h.

Constructor & Destructor Documentation

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector () [inline], [noexcept]

Creates a vector with no elements.

Definition at line 253 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (const allocator_type & __a) [inline], [explicit], [noexcept]

Creates a vector with no elements.

Parameters:
    __a An allocator object.

Definition at line 264 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (size_type __n, const allocator_type & __a = allocator_type()) [inline], [explicit]

Creates a vector with default constructed elements.

Parameters:
    __n The number of elements to initially create.
    __a An allocator.

This constructor fills the vector with __n default constructed elements.

Definition at line 277 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (size_type __n, const value_type & __value, const allocator_type & __a = allocator_type()) [inline]

Creates a vector with copies of an exemplar element.

Parameters:
    __n The number of elements to initially create.
    __value An element to copy.
    __a An allocator.

This constructor fills the vector with __n copies of __value.

Definition at line 289 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (const vector< _Tp, _Alloc > & __x) [inline]

Vector copy constructor.

Parameters:
    __x A vector of identical element and allocator types.

The newly-created vector uses a copy of the allocation object used by __x. All the elements of __x are copied, but any extra memory in __x (for fast expansion) will not be copied.

Definition at line 318 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (vector< _Tp, _Alloc > && __x) [inline], [noexcept]

Vector move constructor.

Parameters:
    __x A vector of identical element and allocator types.

The newly-created vector contains the exact contents of __x. The contents of __x are a valid, but unspecified vector.

Definition at line 335 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (const vector< _Tp, _Alloc > & __x, const allocator_type & __a) [inline]

Copy constructor with alternative allocator.

Definition at line 339 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (vector< _Tp, _Alloc > && __rv, const allocator_type & __m) [inline], [noexcept]

Move constructor with alternative allocator.

Definition at line 348 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::vector (initializer_list< value_type > __l, const allocator_type & __a = allocator_type()) [inline]

Builds a vector from an initializer list.

Parameters:
    __l An initializer_list.
    __a An allocator.

Create a vector consisting of copies of the elements in the initializer_list __l.

This will call the element type's copy constructor N times (where N is __l.size()) and do no memory reallocation.

Definition at line 373 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> std::vector< _Tp, _Alloc >::vector (_InputIterator __first, _InputIterator __last, const allocator_type & __a = allocator_type()) [inline]

Builds a vector from a range.

Parameters:
    __first An input iterator.
    __last An input iterator.
    __a An allocator.

Create a vector consisting of copies of the elements from [first,last).

If the iterators are forward, bidirectional, or random-access, then this will call the elements' copy constructor N times (where N is distance(first,last)) and do no memory reallocation. But if only input iterators are used, then this will do at most 2N calls to the copy constructor, and logN memory reallocations.

Definition at line 401 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> std::vector< _Tp, _Alloc >::~vector () [inline], [noexcept]
The dtor only erases the elements, and note that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 423 of file stl_vector.h.

Member Function Documentation

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _ForwardIterator > pointer std::vector< _Tp, _Alloc >::_M_allocate_and_copy (size_type __n, _ForwardIterator __first, _ForwardIterator __last) [inline], [protected]
Memory expansion handler. Uses the member allocation function to obtain n bytes of memory, and then copies [first,last) into it.

Definition at line 1221 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::_M_range_check (size_type __n) const [inline], [protected]

Safety check used only from at().

Definition at line 800 of file stl_vector.h.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::at().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::assign (size_type __n, const value_type & __val) [inline]

Assigns a given value to a vector.

Parameters:
    __n Number of elements to be assigned.
    __val Value to be assigned.

This function fills a vector with __n copies of the given value. Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 488 of file stl_vector.h.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::assign(), and std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::operator=().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> void std::vector< _Tp, _Alloc >::assign (_InputIterator __first, _InputIterator __last) [inline]

Assigns a range to a vector.

Parameters:
    __first An input iterator.
    __last An input iterator.

This function fills a vector with copies of the elements in the range [__first,__last).

Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 507 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::assign (initializer_list< value_type > __l) [inline]

Assigns an initializer list to a vector.

Parameters:
    __l An initializer_list.

This function fills a vector with copies of the elements in the initializer list __l.

Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 533 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reference std::vector< _Tp, _Alloc >::at (size_type __n) [inline]

Provides access to the data contained in the vector.

Parameters:
    __n The index of the element for which data should be accessed.

Returns:
    Read/write reference to data.

Exceptions:
    std::out_of_range If __n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 822 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reference std::vector< _Tp, _Alloc >::at (size_type __n) const [inline]

Provides access to the data contained in the vector.

Parameters:
    __n The index of the element for which data should be accessed.

Returns:
    Read-only (constant) reference to data.

Exceptions:
    std::out_of_range If __n is an invalid index.

This function provides for safer data access. The parameter is first checked that it is in the range of the vector. The function throws out_of_range if the check fails.

Definition at line 840 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reference std::vector< _Tp, _Alloc >::back () [inline], [noexcept]
Returns a read/write reference to the data at the last element of the vector.

Definition at line 867 of file stl_vector.h.

Referenced by std::piecewise_constant_distribution< _RealType >::max(), and std::piecewise_linear_distribution< _RealType >::max().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reference std::vector< _Tp, _Alloc >::back () const [inline], [noexcept]
Returns a read-only (constant) reference to the data at the last element of the vector.

Definition at line 875 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::begin () [inline], [noexcept]
Returns a read/write iterator that points to the first element in the vector. Iteration is done in ordinary element order.

Definition at line 547 of file stl_vector.h.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::crend(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::empty(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::erase(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::front(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::insert(), __gnu_parallel::multiseq_partition(), __gnu_parallel::multiseq_selection(), __gnu_parallel::multiway_merge_exact_splitting(), std::operator==(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::rend(), and std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::vector().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::vector< _Tp, _Alloc >::begin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the vector. Iteration is done in ordinary element order.

Definition at line 556 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> size_type std::vector< _Tp, _Alloc >::capacity () const [inline], [noexcept]
Returns the total number of elements that the vector can hold before needing to allocate more memory.

Definition at line 734 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::vector< _Tp, _Alloc >::cbegin () const [inline], [noexcept]
Returns a read-only (constant) iterator that points to the first element in the vector. Iteration is done in ordinary element order.

Definition at line 620 of file stl_vector.h.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::erase(), and std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::insert().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::vector< _Tp, _Alloc >::cend () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the vector. Iteration is done in ordinary element order.

Definition at line 629 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::clear () [inline], [noexcept]
Erases all the elements. Note that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1211 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::vector< _Tp, _Alloc >::crbegin () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.

Definition at line 638 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::vector< _Tp, _Alloc >::crend () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.

Definition at line 647 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> _Tp* std::vector< _Tp, _Alloc >::data () [inline], [noexcept]
Returns a pointer such that [data(), data() + size()) is a valid range. For a non-empty vector, data() == &front().

Definition at line 890 of file stl_vector.h.

Referenced by std::regex_traits< _Ch_type >::transform_primary().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename... _Args> iterator std::vector< _Tp, _Alloc >::emplace (const_iterator __position, _Args &&... __args)

Inserts an object in vector before specified iterator.

Parameters:
    __position A const_iterator into the vector.
    __args Arguments.

Returns:
    An iterator that points to the inserted data.

This function will insert an object of type T constructed with T(std::forward<Args>(args)...) before the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::insert().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> bool std::vector< _Tp, _Alloc >::empty () const [inline], [noexcept]
Returns true if the vector is empty. (Thus begin() would equal end().)

Definition at line 743 of file stl_vector.h.

Referenced by std::piecewise_constant_distribution< _RealType >::densities(), std::piecewise_linear_distribution< _RealType >::densities(), std::piecewise_constant_distribution< _RealType >::intervals(), std::piecewise_linear_distribution< _RealType >::intervals(), std::discrete_distribution< _IntType >::max(), std::piecewise_constant_distribution< _RealType >::max(), std::piecewise_linear_distribution< _RealType >::max(), std::piecewise_constant_distribution< _RealType >::min(), std::piecewise_linear_distribution< _RealType >::min(), and std::discrete_distribution< _IntType >::probabilities().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::end () [inline], [noexcept]
Returns a read/write iterator that points one past the last element in the vector. Iteration is done in ordinary element order.

Definition at line 565 of file stl_vector.h.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::back(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::crbegin(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::empty(), __gnu_parallel::multiseq_partition(), __gnu_parallel::multiseq_selection(), __gnu_parallel::multiway_merge_exact_splitting(), std::operator==(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::push_back(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::rbegin(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::resize(), and std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::vector().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_iterator std::vector< _Tp, _Alloc >::end () const [inline], [noexcept]
Returns a read-only (constant) iterator that points one past the last element in the vector. Iteration is done in ordinary element order.

Definition at line 574 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::erase (const_iterator __position) [inline]

Remove element at given position.

Parameters:
    __position Iterator pointing to element to be erased.

Returns:
    An iterator pointing to the next element (or end()).

This function will erase the element at the given position and thus shorten the vector by one.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the element, and that if the element is itself a pointer, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1146 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::erase (const_iterator __first, const_iterator __last) [inline]

Remove a range of elements.

Parameters:
    __first Iterator pointing to the first element to be erased.
    __last Iterator pointing to one past the last element to be erased.

Returns:
    An iterator pointing to the element pointed to by __last prior to erasing (or end()).

This function will erase the elements in the range [__first,__last) and shorten the vector accordingly.

Note This operation could be expensive and if it is frequently used the user should consider using std::list. The user is also cautioned that this function only erases the elements, and that if the elements themselves are pointers, the pointed-to memory is not touched in any way. Managing the pointer is the user's responsibility.

Definition at line 1173 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reference std::vector< _Tp, _Alloc >::front () [inline], [noexcept]
Returns a read/write reference to the data at the first element of the vector.

Definition at line 851 of file stl_vector.h.

Referenced by std::piecewise_constant_distribution< _RealType >::min(), and std::piecewise_linear_distribution< _RealType >::min().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reference std::vector< _Tp, _Alloc >::front () const [inline], [noexcept]
Returns a read-only (constant) reference to the data at the first element of the vector.

Definition at line 859 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::insert (const_iterator __position, const value_type & __x)

Inserts given value into vector before specified iterator.

Parameters:
    __position A const_iterator into the vector.
    __x Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a copy of the given value before the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Referenced by std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::insert(), and std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::resize().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::insert (const_iterator __position, value_type && __x) [inline]

Inserts given rvalue into vector before specified iterator.

Parameters:
    __position A const_iterator into the vector.
    __x Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a copy of the given rvalue before the specified location. Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 1014 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::insert (const_iterator __position, initializer_list< value_type > __l) [inline]

Inserts an initializer_list into the vector.

Parameters:
    __position An iterator into the vector.
    __l An initializer_list.

This function will insert copies of the data in the initializer_list l into the vector before the location specified by position.

Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 1031 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> iterator std::vector< _Tp, _Alloc >::insert (const_iterator __position, size_type __n, const value_type & __x) [inline]

Inserts a number of copies of given data into the vector.

Parameters:
    __position A const_iterator into the vector.
    __n Number of elements to be inserted.
    __x Data to be inserted.

Returns:
    An iterator that points to the inserted data.

This function will insert a specified number of copies of the given data before the location specified by position.

Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 1051 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> template<typename _InputIterator , typename = std::_RequireInputIter<_InputIterator>> iterator std::vector< _Tp, _Alloc >::insert (const_iterator __position, _InputIterator __first, _InputIterator __last) [inline]

Inserts a range into the vector.

Parameters:
    __position A const_iterator into the vector.
    __first An input iterator.
    __last An input iterator.

Returns:
    An iterator that points to the inserted data.

This function will insert copies of the data in the range [__first,__last) into the vector before the location specified by pos.

Note that this kind of operation could be expensive for a vector and if it is frequently used the user should consider using std::list.

Definition at line 1095 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> size_type std::vector< _Tp, _Alloc >::max_size () const [inline], [noexcept]
Returns the size() of the largest possible vector.

Definition at line 659 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> vector& std::vector< _Tp, _Alloc >::operator= (const vector< _Tp, _Alloc > & __x)

Vector assignment operator.

Parameters:
    __x A vector of identical element and allocator types.

All the elements of __x are copied, but any extra memory in __x (for fast expansion) will not be copied. Unlike the copy constructor, the allocator object is not copied.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> vector& std::vector< _Tp, _Alloc >::operator= (vector< _Tp, _Alloc > && __x) [inline], [noexcept]

Vector move assignment operator.

Parameters:
    __x A vector of identical element and allocator types.

The contents of __x are moved into this vector (without copying, if the allocators permit it). __x is a valid, but unspecified vector.

Definition at line 448 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> vector& std::vector< _Tp, _Alloc >::operator= (initializer_list< value_type > __l) [inline]

Vector list assignment operator.

Parameters:
    __l An initializer_list.

This function fills a vector with copies of the elements in the initializer list __l.

Note that the assignment completely changes the vector and that the resulting vector's size is the same as the number of elements assigned. Old data may be lost.

Definition at line 470 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reference std::vector< _Tp, _Alloc >::operator[] (size_type __n) [inline], [noexcept]

Subscript access to the data contained in the vector.

Parameters:
    __n The index of the element for which data should be accessed.

Returns:
    Read/write reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 779 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reference std::vector< _Tp, _Alloc >::operator[] (size_type __n) const [inline], [noexcept]

Subscript access to the data contained in the vector.

Parameters:
    __n The index of the element for which data should be accessed.

Returns:
    Read-only (constant) reference to data.

This operator allows for easy, array-style, data access. Note that data access with this operator is unchecked and out_of_range lookups are not defined. (For checked lookups see at().)

Definition at line 794 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::pop_back () [inline], [noexcept]

Removes last element. This is a typical stack operation. It shrinks the vector by one.

Note that no data is returned, and if the last element's data is needed, it should be retrieved before pop_back() is called.

Definition at line 949 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::push_back (const value_type & __x) [inline]

Add data to the end of the vector.

Parameters:
    __x Data to be added.

This is a typical stack operation. The function creates an element at the end of the vector and assigns the given data to it. Due to the nature of a vector this operation can be done in constant time if the vector has preallocated space available.

Definition at line 913 of file stl_vector.h.

Referenced by __gnu_parallel::multiseq_partition(), and __gnu_parallel::multiseq_selection().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reverse_iterator std::vector< _Tp, _Alloc >::rbegin () [inline], [noexcept]
Returns a read/write reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.

Definition at line 583 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::vector< _Tp, _Alloc >::rbegin () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to the last element in the vector. Iteration is done in reverse element order.

Definition at line 592 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> reverse_iterator std::vector< _Tp, _Alloc >::rend () [inline], [noexcept]
Returns a read/write reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.

Definition at line 601 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> const_reverse_iterator std::vector< _Tp, _Alloc >::rend () const [inline], [noexcept]
Returns a read-only (constant) reverse iterator that points to one before the first element in the vector. Iteration is done in reverse element order.

Definition at line 610 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::reserve (size_type __n)

Attempt to preallocate enough memory for specified number of elements.

Parameters:
    __n Number of elements required.

Exceptions:
    std::length_error If n exceeds max_size().

This function attempts to reserve enough memory for the vector to hold the specified number of elements. If the number requested is more than max_size(), length_error is thrown.

The advantage of this function is that if optimal code is a necessity and the user can determine the number of elements that will be required, the user can reserve the memory in advance, and thus prevent a possible reallocation of memory and copying of vector data.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::resize (size_type __new_size) [inline]

Resizes the vector to the specified number of elements.

Parameters:
    __new_size Number of elements the vector should contain.

This function will resize the vector to the specified number of elements. If the number is smaller than the vector's current size the vector is truncated, otherwise default constructed elements are appended.

Definition at line 673 of file stl_vector.h.

Referenced by __gnu_parallel::__shrink_and_double(), and __gnu_parallel::multiway_merge_exact_splitting().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::resize (size_type __new_size, const value_type & __x) [inline]

Resizes the vector to the specified number of elements.

Parameters:
    __new_size Number of elements the vector should contain.
    __x Data with which new elements should be populated.

This function will resize the vector to the specified number of elements. If the number is smaller than the vector's current size the vector is truncated, otherwise the vector is extended and new elements are populated with given data.

Definition at line 693 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::shrink_to_fit () [inline]
A non-binding request to reduce capacity() to size().

Definition at line 725 of file stl_vector.h.

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> size_type std::vector< _Tp, _Alloc >::size () const [inline], [noexcept]
Returns the number of elements in the vector.

Definition at line 654 of file stl_vector.h.

Referenced by __gnu_parallel::__shrink(), __gnu_parallel::__shrink_and_double(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::_M_range_check(), __gnu_parallel::list_partition(), std::discrete_distribution< _IntType >::max(), std::operator==(), std::vector< sub_match< _Bi_iter >, allocator< sub_match< _Bi_iter > > >::resize(), and std::regex_traits< _Ch_type >::transform_primary().

  template<typename _Tp, typename _Alloc = std::allocator<_Tp>> void std::vector< _Tp, _Alloc >::swap (vector< _Tp, _Alloc > & __x) [inline], [noexcept]

Swaps data with another vector.

Parameters:
    __x A vector of the same element and allocator types.

This exchanges the elements between two vectors in constant time. (Three pointers, so it should be quite fast.) Note that the global std::swap() function is specialized such that std::swap(v1,v2) will feed to this function.

Definition at line 1194 of file stl_vector.h.

Referenced by std::swap().

Author

Generated automatically by Doxygen for libstdc++ from the source code.